<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>A4988Driver: a4988.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">A4988Driver
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">a4988.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="a4988_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;<span class="preprocessor">#ifndef A4988_A4988_H_</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="preprocessor">#define A4988_A4988_H_</span></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;<span class="preprocessor">#include &quot;stdint.h&quot;</span></div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="preprocessor">#include &quot;stdbool.h&quot;</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="preprocessor">#include &quot;main.h&quot;</span></div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;<span class="preprocessor">#include &quot;stm32f1xx.h&quot;</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="preprocessor">#include &quot;stm32f1xx_hal.h&quot;</span></div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="preprocessor">#include &quot;stm32f1xx_hal_gpio.h&quot;</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="preprocessor">#include &quot;gpio.h&quot;</span></div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;</div><div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622">   66</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span> {</div><div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622a33cf1d8ef1d06ee698a7fabf40eb3a7f">   67</a></span>&#160;    <a class="code" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622a33cf1d8ef1d06ee698a7fabf40eb3a7f">ACTIVE</a>,         </div><div class="line"><a name="l00068"></a><span class="lineno"><a class="line" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622aac132f2982b98bcaa3445e535a03ff75">   68</a></span>&#160;    <a class="code" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622aac132f2982b98bcaa3445e535a03ff75">OFF</a>,            </div><div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622ad6137abebe4fdc59e2f0f2c84bdbe3fa">   69</a></span>&#160;    <a class="code" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622ad6137abebe4fdc59e2f0f2c84bdbe3fa">SLEEP</a>,          </div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;} <a class="code" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622">driverStatus</a>;                 <span class="comment">//Enumeración que define el estado del motor.</span></div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0">   76</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span> {</div><div class="line"><a name="l00077"></a><span class="lineno"><a class="line" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0ad08f8ac0aa8dfb59589824359772459e">   77</a></span>&#160;    <a class="code" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0ad08f8ac0aa8dfb59589824359772459e">FULL</a> = 1,       </div><div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a51df22c376649e022134d738e8d8641a">   78</a></span>&#160;    <a class="code" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a51df22c376649e022134d738e8d8641a">HALF</a> = 2,       </div><div class="line"><a name="l00079"></a><span class="lineno"><a class="line" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a8dd9342a0e4fd716d2beb9961f5deeed">   79</a></span>&#160;    <a class="code" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a8dd9342a0e4fd716d2beb9961f5deeed">QUARTER</a> = 4,    </div><div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a2fd39b67b424f4ea3b4c11ce3195ab8b">   80</a></span>&#160;    <a class="code" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a2fd39b67b424f4ea3b4c11ce3195ab8b">EIGHT</a> = 8,      </div><div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a3cc9428274f66ec477863bbf676438c8">   81</a></span>&#160;    <a class="code" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a3cc9428274f66ec477863bbf676438c8">SIXTEENTH</a> = 16, </div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;} <a class="code" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0">microStep</a>;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="structa4988_handler.html">   90</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span>{</div><div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="structa4988_handler.html#ad58bb9d10d11d874bb55865bb8a7ca2a">   91</a></span>&#160;    GPIO_TypeDef *<a class="code" href="structa4988_handler.html#ad58bb9d10d11d874bb55865bb8a7ca2a">EN_PORT</a>;          </div><div class="line"><a name="l00092"></a><span class="lineno"><a class="line" href="structa4988_handler.html#a464ea2ca2566af32ddd2be6c597aa2ad">   92</a></span>&#160;    uint16_t <a class="code" href="structa4988_handler.html#a464ea2ca2566af32ddd2be6c597aa2ad">EN_PIN</a>;                </div><div class="line"><a name="l00093"></a><span class="lineno"><a class="line" href="structa4988_handler.html#a94941df86d5999aec0219c6bfe4f42b2">   93</a></span>&#160;    GPIO_TypeDef *<a class="code" href="structa4988_handler.html#a94941df86d5999aec0219c6bfe4f42b2">STEP_PORT</a>;        </div><div class="line"><a name="l00094"></a><span class="lineno"><a class="line" href="structa4988_handler.html#ad208d8cc0de2201171b95649d744a2b9">   94</a></span>&#160;    uint16_t <a class="code" href="structa4988_handler.html#ad208d8cc0de2201171b95649d744a2b9">STEP_PIN</a>;              </div><div class="line"><a name="l00095"></a><span class="lineno"><a class="line" href="structa4988_handler.html#ad6b16cf6efd58235600d7fe073f9f4e3">   95</a></span>&#160;    GPIO_TypeDef *<a class="code" href="structa4988_handler.html#ad6b16cf6efd58235600d7fe073f9f4e3">DIR_PORT</a>;         </div><div class="line"><a name="l00096"></a><span class="lineno"><a class="line" href="structa4988_handler.html#a8ae7c243b84a9b7239062b46831d3a2c">   96</a></span>&#160;    uint16_t <a class="code" href="structa4988_handler.html#a8ae7c243b84a9b7239062b46831d3a2c">DIR_PIN</a>;               </div><div class="line"><a name="l00097"></a><span class="lineno"><a class="line" href="structa4988_handler.html#a36a117294bb9f01149cd2b3fb56e3195">   97</a></span>&#160;    <span class="keywordtype">float</span> <a class="code" href="structa4988_handler.html#a36a117294bb9f01149cd2b3fb56e3195">degreeCount</a>;              </div><div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="structa4988_handler.html#a64fef8e0e1a8071b1ba817e3d38dc6e9">   98</a></span>&#160;    <span class="keywordtype">float</span> <a class="code" href="structa4988_handler.html#a64fef8e0e1a8071b1ba817e3d38dc6e9">stepsPerTurn</a>;             </div><div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="structa4988_handler.html#ad51f96267735fd1c81b0bb63530eeb09">   99</a></span>&#160;    <a class="code" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622">driverStatus</a> <a class="code" href="structa4988_handler.html#ad51f96267735fd1c81b0bb63530eeb09">status</a>;            </div><div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="structa4988_handler.html#aa6419d0080b8d90e315600a51cafbd50">  100</a></span>&#160;    int64_t <a class="code" href="structa4988_handler.html#aa6419d0080b8d90e315600a51cafbd50">stepsCount</a>;             </div><div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="structa4988_handler.html#af49728ffceff31645ba020df66f2804d">  101</a></span>&#160;    uint32_t <a class="code" href="structa4988_handler.html#af49728ffceff31645ba020df66f2804d">stepDuration</a>;          </div><div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="structa4988_handler.html#a389a2f0528c7e35a513aacbc67ea62b6">  102</a></span>&#160;    <a class="code" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0">microStep</a> <a class="code" href="structa4988_handler.html#a389a2f0528c7e35a513aacbc67ea62b6">microstp</a>;             </div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;} <a class="code" href="structa4988_handler.html">a4988Handler</a>;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="keywordtype">void</span> <a class="code" href="a4988_8h.html#a83a5e4ad4b743e7a5e5e3667d5b5af90">a4988_init</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler, GPIO_TypeDef *en_port,</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        uint32_t en_pin, GPIO_TypeDef *step_port, uint32_t step_pin,</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;        GPIO_TypeDef *dir_port, uint32_t dir_pin);</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="a4988_8h.html#a6cd8fcd5ab73faea97783466d496782b">a4988_incStep</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler);</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="a4988_8h.html#a616386d44c4d6ab3acd4bfe79f4526c3">a4988_incSteps</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler, uint32_t steps);</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="a4988_8h.html#a25f9bb9576d05153c805e499b5ead280">a4988_decStep</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler);</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="keywordtype">bool</span> <a class="code" href="a4988_8h.html#a694a6c6580c3e70029ecf890b18662d9">a4988_decSteps</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler, uint32_t steps);</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="keywordtype">void</span> <a class="code" href="a4988_8h.html#a50b770ddd61a733c0b93674a6e043941">a4988_setMicroStep</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler, <a class="code" href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0">microStep</a> step);</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="keywordtype">void</span> <a class="code" href="a4988_8h.html#a2c4fb12bcdcffea40744538616b5f7e4">a4988_setStepsPerTurn</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler, <span class="keywordtype">float</span> steps);</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;<span class="keywordtype">void</span> <a class="code" href="a4988_8h.html#a8c6e8d00fb33d5b8d8b1be976b2d8773">a4988_setSteps</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler, int64_t steps);</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="keywordtype">float</span> <a class="code" href="a4988_8h.html#a05f902e3d1ee0b82d70fa65d8955423b">a4988_getDegreeCount</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler);</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;int64_t <a class="code" href="a4988_8h.html#ab2c561e95b718d8f275f41f7ec44113b">a4988_getSteps</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler);</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="keywordtype">void</span> <a class="code" href="a4988_8h.html#a4636e615969f0762717be85f3fae99b2">a4988_resetSteps</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler);</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="keywordtype">void</span> <a class="code" href="a4988_8h.html#aac1c631bf4552cbc8e1af42cf426f154">a4988_setStatus</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler, <a class="code" href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622">driverStatus</a> status);</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;<span class="keywordtype">void</span> <a class="code" href="a4988_8h.html#a957c1d38216e19e2d33514fba8290797">a4988_setSpeed</a>(<a class="code" href="structa4988_handler.html">a4988Handler</a> *driver_handler, uint32_t speed);</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* A4988_A4988_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="a4988_8h_html_a957c1d38216e19e2d33514fba8290797"><div class="ttname"><a href="a4988_8h.html#a957c1d38216e19e2d33514fba8290797">a4988_setSpeed</a></div><div class="ttdeci">void a4988_setSpeed(a4988Handler *driver_handler, uint32_t speed)</div><div class="ttdoc">Calculates the delay of each step in order to reach the desired speed. In order to calculate it prope...</div><div class="ttdef"><b>Definition:</b> a4988.c:151</div></div>
<div class="ttc" id="a4988_8h_html_a05f902e3d1ee0b82d70fa65d8955423b"><div class="ttname"><a href="a4988_8h.html#a05f902e3d1ee0b82d70fa65d8955423b">a4988_getDegreeCount</a></div><div class="ttdeci">float a4988_getDegreeCount(a4988Handler *driver_handler)</div><div class="ttdoc">Get how many degrees has the motor rotated. </div><div class="ttdef"><b>Definition:</b> a4988.c:111</div></div>
<div class="ttc" id="structa4988_handler_html_a464ea2ca2566af32ddd2be6c597aa2ad"><div class="ttname"><a href="structa4988_handler.html#a464ea2ca2566af32ddd2be6c597aa2ad">a4988Handler::EN_PIN</a></div><div class="ttdeci">uint16_t EN_PIN</div><div class="ttdoc">Reference to ENABLE pin. </div><div class="ttdef"><b>Definition:</b> a4988.h:92</div></div>
<div class="ttc" id="a4988_8h_html_a6086cd48f9d99d3c531787235d509622a33cf1d8ef1d06ee698a7fabf40eb3a7f"><div class="ttname"><a href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622a33cf1d8ef1d06ee698a7fabf40eb3a7f">ACTIVE</a></div><div class="ttdoc">ACTIVE state. </div><div class="ttdef"><b>Definition:</b> a4988.h:67</div></div>
<div class="ttc" id="a4988_8h_html_a2c4fb12bcdcffea40744538616b5f7e4"><div class="ttname"><a href="a4988_8h.html#a2c4fb12bcdcffea40744538616b5f7e4">a4988_setStepsPerTurn</a></div><div class="ttdeci">void a4988_setStepsPerTurn(a4988Handler *driver_handler, float steps)</div><div class="ttdoc">Set the amount of steps to make in order to rotate a turn. DO NOT TAKE IN COUNT MICROSTEPS. See Stepper motor datasheet. </div><div class="ttdef"><b>Definition:</b> a4988.c:107</div></div>
<div class="ttc" id="structa4988_handler_html"><div class="ttname"><a href="structa4988_handler.html">a4988Handler</a></div><div class="ttdoc">this struct saves all the information related to the driver status. </div><div class="ttdef"><b>Definition:</b> a4988.h:90</div></div>
<div class="ttc" id="a4988_8h_html_a26a4a9fc10f890a34859f53d114f08b0a8dd9342a0e4fd716d2beb9961f5deeed"><div class="ttname"><a href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a8dd9342a0e4fd716d2beb9961f5deeed">QUARTER</a></div><div class="ttdoc">1/4 of a step </div><div class="ttdef"><b>Definition:</b> a4988.h:79</div></div>
<div class="ttc" id="a4988_8h_html_a26a4a9fc10f890a34859f53d114f08b0a2fd39b67b424f4ea3b4c11ce3195ab8b"><div class="ttname"><a href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a2fd39b67b424f4ea3b4c11ce3195ab8b">EIGHT</a></div><div class="ttdoc">1/8 of a step </div><div class="ttdef"><b>Definition:</b> a4988.h:80</div></div>
<div class="ttc" id="structa4988_handler_html_ad6b16cf6efd58235600d7fe073f9f4e3"><div class="ttname"><a href="structa4988_handler.html#ad6b16cf6efd58235600d7fe073f9f4e3">a4988Handler::DIR_PORT</a></div><div class="ttdeci">GPIO_TypeDef * DIR_PORT</div><div class="ttdoc">Pointer to DIR port. </div><div class="ttdef"><b>Definition:</b> a4988.h:95</div></div>
<div class="ttc" id="structa4988_handler_html_aa6419d0080b8d90e315600a51cafbd50"><div class="ttname"><a href="structa4988_handler.html#aa6419d0080b8d90e315600a51cafbd50">a4988Handler::stepsCount</a></div><div class="ttdeci">int64_t stepsCount</div><div class="ttdoc">Software count of how many steps has the motor has move since starting point. </div><div class="ttdef"><b>Definition:</b> a4988.h:100</div></div>
<div class="ttc" id="structa4988_handler_html_ad51f96267735fd1c81b0bb63530eeb09"><div class="ttname"><a href="structa4988_handler.html#ad51f96267735fd1c81b0bb63530eeb09">a4988Handler::status</a></div><div class="ttdeci">driverStatus status</div><div class="ttdoc">Status of the motor (ACTIVE, OFF). </div><div class="ttdef"><b>Definition:</b> a4988.h:99</div></div>
<div class="ttc" id="a4988_8h_html_ab2c561e95b718d8f275f41f7ec44113b"><div class="ttname"><a href="a4988_8h.html#ab2c561e95b718d8f275f41f7ec44113b">a4988_getSteps</a></div><div class="ttdeci">int64_t a4988_getSteps(a4988Handler *driver_handler)</div><div class="ttdoc">returns the number of steps that the motor has made. </div><div class="ttdef"><b>Definition:</b> a4988.c:115</div></div>
<div class="ttc" id="a4988_8h_html_a83a5e4ad4b743e7a5e5e3667d5b5af90"><div class="ttname"><a href="a4988_8h.html#a83a5e4ad4b743e7a5e5e3667d5b5af90">a4988_init</a></div><div class="ttdeci">void a4988_init(a4988Handler *driver_handler, GPIO_TypeDef *en_port, uint32_t en_pin, GPIO_TypeDef *step_port, uint32_t step_pin, GPIO_TypeDef *dir_port, uint32_t dir_pin)</div><div class="ttdoc">Initialize the driver. Assigns the pins for each control in order to control the motor. </div><div class="ttdef"><b>Definition:</b> a4988.c:15</div></div>
<div class="ttc" id="structa4988_handler_html_a36a117294bb9f01149cd2b3fb56e3195"><div class="ttname"><a href="structa4988_handler.html#a36a117294bb9f01149cd2b3fb56e3195">a4988Handler::degreeCount</a></div><div class="ttdeci">float degreeCount</div><div class="ttdoc">Software count of the degrees that the motor has rotated since starting point. </div><div class="ttdef"><b>Definition:</b> a4988.h:97</div></div>
<div class="ttc" id="structa4988_handler_html_a64fef8e0e1a8071b1ba817e3d38dc6e9"><div class="ttname"><a href="structa4988_handler.html#a64fef8e0e1a8071b1ba817e3d38dc6e9">a4988Handler::stepsPerTurn</a></div><div class="ttdeci">float stepsPerTurn</div><div class="ttdoc">Stores how many steps has to be sent in order to spin a turn (withouth microstepping). </div><div class="ttdef"><b>Definition:</b> a4988.h:98</div></div>
<div class="ttc" id="a4988_8h_html_a694a6c6580c3e70029ecf890b18662d9"><div class="ttname"><a href="a4988_8h.html#a694a6c6580c3e70029ecf890b18662d9">a4988_decSteps</a></div><div class="ttdeci">bool a4988_decSteps(a4988Handler *driver_handler, uint32_t steps)</div><div class="ttdoc">Decrements an specific amount of steps in the motor. </div><div class="ttdef"><b>Definition:</b> a4988.c:84</div></div>
<div class="ttc" id="structa4988_handler_html_a389a2f0528c7e35a513aacbc67ea62b6"><div class="ttname"><a href="structa4988_handler.html#a389a2f0528c7e35a513aacbc67ea62b6">a4988Handler::microstp</a></div><div class="ttdeci">microStep microstp</div><div class="ttdoc">Enumeration that sets how many microsteps are set. </div><div class="ttdef"><b>Definition:</b> a4988.h:102</div></div>
<div class="ttc" id="a4988_8h_html_a50b770ddd61a733c0b93674a6e043941"><div class="ttname"><a href="a4988_8h.html#a50b770ddd61a733c0b93674a6e043941">a4988_setMicroStep</a></div><div class="ttdeci">void a4988_setMicroStep(a4988Handler *driver_handler, microStep step)</div><div class="ttdoc">Sets how many microsteps are set in Pololu driver To check hoe many microsteps are configured...</div><div class="ttdef"><b>Definition:</b> a4988.c:103</div></div>
<div class="ttc" id="a4988_8h_html_a26a4a9fc10f890a34859f53d114f08b0a3cc9428274f66ec477863bbf676438c8"><div class="ttname"><a href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a3cc9428274f66ec477863bbf676438c8">SIXTEENTH</a></div><div class="ttdoc">1/16 of a step </div><div class="ttdef"><b>Definition:</b> a4988.h:81</div></div>
<div class="ttc" id="a4988_8h_html_a25f9bb9576d05153c805e499b5ead280"><div class="ttname"><a href="a4988_8h.html#a25f9bb9576d05153c805e499b5ead280">a4988_decStep</a></div><div class="ttdeci">bool a4988_decStep(a4988Handler *driver_handler)</div><div class="ttdoc">Decrements a simgle step in the motor. </div><div class="ttdef"><b>Definition:</b> a4988.c:67</div></div>
<div class="ttc" id="a4988_8h_html_a26a4a9fc10f890a34859f53d114f08b0a51df22c376649e022134d738e8d8641a"><div class="ttname"><a href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0a51df22c376649e022134d738e8d8641a">HALF</a></div><div class="ttdoc">1/2 of a step </div><div class="ttdef"><b>Definition:</b> a4988.h:78</div></div>
<div class="ttc" id="a4988_8h_html_a8c6e8d00fb33d5b8d8b1be976b2d8773"><div class="ttname"><a href="a4988_8h.html#a8c6e8d00fb33d5b8d8b1be976b2d8773">a4988_setSteps</a></div><div class="ttdeci">void a4988_setSteps(a4988Handler *driver_handler, int64_t steps)</div><div class="ttdoc">Set a new amount of steps taken. </div><div class="ttdef"><b>Definition:</b> a4988.c:125</div></div>
<div class="ttc" id="structa4988_handler_html_af49728ffceff31645ba020df66f2804d"><div class="ttname"><a href="structa4988_handler.html#af49728ffceff31645ba020df66f2804d">a4988Handler::stepDuration</a></div><div class="ttdeci">uint32_t stepDuration</div><div class="ttdoc">Duration in us of the motor. This sets the speed of the movement. </div><div class="ttdef"><b>Definition:</b> a4988.h:101</div></div>
<div class="ttc" id="a4988_8h_html_a6cd8fcd5ab73faea97783466d496782b"><div class="ttname"><a href="a4988_8h.html#a6cd8fcd5ab73faea97783466d496782b">a4988_incStep</a></div><div class="ttdeci">bool a4988_incStep(a4988Handler *driver_handler)</div><div class="ttdoc">Increments a step in the motor. </div><div class="ttdef"><b>Definition:</b> a4988.c:32</div></div>
<div class="ttc" id="a4988_8h_html_a6086cd48f9d99d3c531787235d509622ad6137abebe4fdc59e2f0f2c84bdbe3fa"><div class="ttname"><a href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622ad6137abebe4fdc59e2f0f2c84bdbe3fa">SLEEP</a></div><div class="ttdoc">SLEEP state. </div><div class="ttdef"><b>Definition:</b> a4988.h:69</div></div>
<div class="ttc" id="structa4988_handler_html_ad208d8cc0de2201171b95649d744a2b9"><div class="ttname"><a href="structa4988_handler.html#ad208d8cc0de2201171b95649d744a2b9">a4988Handler::STEP_PIN</a></div><div class="ttdeci">uint16_t STEP_PIN</div><div class="ttdoc">Pointer to STEP pin. </div><div class="ttdef"><b>Definition:</b> a4988.h:94</div></div>
<div class="ttc" id="a4988_8h_html_a616386d44c4d6ab3acd4bfe79f4526c3"><div class="ttname"><a href="a4988_8h.html#a616386d44c4d6ab3acd4bfe79f4526c3">a4988_incSteps</a></div><div class="ttdeci">bool a4988_incSteps(a4988Handler *driver_handler, uint32_t steps)</div><div class="ttdoc">Increments an specific amount of steps in the motor. </div><div class="ttdef"><b>Definition:</b> a4988.c:48</div></div>
<div class="ttc" id="a4988_8h_html_a26a4a9fc10f890a34859f53d114f08b0"><div class="ttname"><a href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0">microStep</a></div><div class="ttdeci">microStep</div><div class="ttdoc">Microsteps set in the driver by pins MS1, MS2, MS3. </div><div class="ttdef"><b>Definition:</b> a4988.h:76</div></div>
<div class="ttc" id="structa4988_handler_html_a8ae7c243b84a9b7239062b46831d3a2c"><div class="ttname"><a href="structa4988_handler.html#a8ae7c243b84a9b7239062b46831d3a2c">a4988Handler::DIR_PIN</a></div><div class="ttdeci">uint16_t DIR_PIN</div><div class="ttdoc">Pointer to DIR pin. </div><div class="ttdef"><b>Definition:</b> a4988.h:96</div></div>
<div class="ttc" id="a4988_8h_html_a6086cd48f9d99d3c531787235d509622aac132f2982b98bcaa3445e535a03ff75"><div class="ttname"><a href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622aac132f2982b98bcaa3445e535a03ff75">OFF</a></div><div class="ttdoc">OFF state. </div><div class="ttdef"><b>Definition:</b> a4988.h:68</div></div>
<div class="ttc" id="a4988_8h_html_aac1c631bf4552cbc8e1af42cf426f154"><div class="ttname"><a href="a4988_8h.html#aac1c631bf4552cbc8e1af42cf426f154">a4988_setStatus</a></div><div class="ttdeci">void a4988_setStatus(a4988Handler *driver_handler, driverStatus status)</div><div class="ttdoc">Set the motor to ACTIVE or OFF. </div><div class="ttdef"><b>Definition:</b> a4988.c:133</div></div>
<div class="ttc" id="structa4988_handler_html_ad58bb9d10d11d874bb55865bb8a7ca2a"><div class="ttname"><a href="structa4988_handler.html#ad58bb9d10d11d874bb55865bb8a7ca2a">a4988Handler::EN_PORT</a></div><div class="ttdeci">GPIO_TypeDef * EN_PORT</div><div class="ttdoc">Pointer to ENABLE port. </div><div class="ttdef"><b>Definition:</b> a4988.h:91</div></div>
<div class="ttc" id="structa4988_handler_html_a94941df86d5999aec0219c6bfe4f42b2"><div class="ttname"><a href="structa4988_handler.html#a94941df86d5999aec0219c6bfe4f42b2">a4988Handler::STEP_PORT</a></div><div class="ttdeci">GPIO_TypeDef * STEP_PORT</div><div class="ttdoc">Pointer to STEP port. </div><div class="ttdef"><b>Definition:</b> a4988.h:93</div></div>
<div class="ttc" id="a4988_8h_html_a26a4a9fc10f890a34859f53d114f08b0ad08f8ac0aa8dfb59589824359772459e"><div class="ttname"><a href="a4988_8h.html#a26a4a9fc10f890a34859f53d114f08b0ad08f8ac0aa8dfb59589824359772459e">FULL</a></div><div class="ttdoc">FULL step (no microstepping) </div><div class="ttdef"><b>Definition:</b> a4988.h:77</div></div>
<div class="ttc" id="a4988_8h_html_a4636e615969f0762717be85f3fae99b2"><div class="ttname"><a href="a4988_8h.html#a4636e615969f0762717be85f3fae99b2">a4988_resetSteps</a></div><div class="ttdeci">void a4988_resetSteps(a4988Handler *driver_handler)</div><div class="ttdoc">Reset the step count of the motor. </div><div class="ttdef"><b>Definition:</b> a4988.c:129</div></div>
<div class="ttc" id="a4988_8h_html_a6086cd48f9d99d3c531787235d509622"><div class="ttname"><a href="a4988_8h.html#a6086cd48f9d99d3c531787235d509622">driverStatus</a></div><div class="ttdeci">driverStatus</div><div class="ttdoc">Possible status of the driver. </div><div class="ttdef"><b>Definition:</b> a4988.h:66</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
